# Event Tracking

The Hackle SDK provides the ability to send user events to Hackle. By using this feature at every point where a change in user behavior occurs, you can obtain meaningful data about user behavior, and analyze user behavior through the collected data.

## track

You can send user events by passing an **Event Key** and **User Identifier** to the `track()` method.

### Event Name (key)

* It is recommended to name it like a typical variable name but make it easy to identify.
* Character limit is 128 characters. (128 characters)

### Example

Assume you have defined an Event Key called `purchase` to collect events when a user clicks the purchase button.

```php
<?php

require 'vendor/autoload.php';

$client = \Hackle\HackleClients::create("YOUR_SDK_KEY");

// "ae2182e0"라는 식별자를 가진 사용자가 발생시킨 "purchase"라는 이벤트를
// 숫자 값과 함께 전송
$user = \Hackle\Common\HackleUser::builder()
    ->deviceId("ae2182e0")
    ->build();
$event = \Hackle\Common\HackleEvent::builder("purchase")
    ->property("pay_method", "CARD")
    ->property("discount_amount", 800)
    ->property("is_discount", true)
    ->build();

$client->track($event, $user);

?>
```

## Property

The Hackle SDK supports adding properties to Event objects.

* A property must be sent as a pair of a Property Key (key) and a Property Value (value).
* The maximum number of properties that can be added to an event object is 64.

<table><thead><tr><th width="133.04296875">Category</th><th width="127.60546875">Type</th><th>Constraints</th></tr></thead><tbody><tr><td>Property Key</td><td><code>string</code></td><td><ul><li>Character limit is 128 characters.</li><li>Case-insensitive.</li><li>For example, AGE and age are recognized as the same Property Key.</li></ul></td></tr><tr><td>Property Value</td><td><code>boolean</code>, <code>string</code>, <code>number</code>, <code>array</code></td><td><ul><li>For string type, the character limit is 1024 characters.</li><li>String type is case-sensitive.</li><li>For example, APPLE and apple are recognized as different Property Values.</li><li>For number type, up to 15 integer digits and up to 6 decimal places are supported.</li></ul></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/php/php-track.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
